// PrintControlView.cpp : implementation of the CPrintControlView class
//

#include "stdafx.h"
#include "PrintControl.h"

#include "PrintControlDoc.h"
#include "PrintControlView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrintControlView

IMPLEMENT_DYNCREATE(CPrintControlView, CFormView)

BEGIN_MESSAGE_MAP(CPrintControlView, CFormView)
	//{{AFX_MSG_MAP(CPrintControlView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrintControlView construction/destruction

CPrintControlView::CPrintControlView()
	: CFormView(CPrintControlView::IDD)
{
	//{{AFX_DATA_INIT(CPrintControlView)
	m_nControlChoice = 0;
	m_nPrintChoice = 0;
	//}}AFX_DATA_INIT
	// TODO: add construction code here
}

CPrintControlView::~CPrintControlView()
{
}

void CPrintControlView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPrintControlView)
	DDX_Control(pDX, IDC_PICTURE, m_ctlPicture);
	DDX_Radio(pDX, IDC_CONTROL1, m_nControlChoice);
	DDX_Control(pDX, IDC_CALENDAR1, m_ctlCalendar);
	DDX_Control(pDX, IDC_MSCHART1, m_ctlChart);
	DDX_Radio(pDX, IDC_RADIO_PRINT1, m_nPrintChoice);
	//}}AFX_DATA_MAP
}

BOOL CPrintControlView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CPrintControlView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
}

/////////////////////////////////////////////////////////////////////////////
// CPrintControlView diagnostics

#ifdef _DEBUG
void CPrintControlView::AssertValid() const
{
	CFormView::AssertValid();
}

void CPrintControlView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CPrintControlDoc* CPrintControlView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPrintControlDoc)));
	return (CPrintControlDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPrintControlView printing

BOOL CPrintControlView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// limit pages for testing
	pInfo->SetMinPage(1); 
	pInfo->SetMaxPage(1); 

	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPrintControlView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
}

void CPrintControlView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
}

/////////////////////////////////////////////////////////////////////////////
// Demonstration code

// *********************************************************
//	ErrorMessage
//
//	Looks up and displays an error message. 
//
//	Arguments:
//
//		hr - (HRESULT, input) the error code
//		strError - (CString, input) the error string (may be blank)
//
//	Returns:
//
//		Nothing
//

void ErrorMessage(HRESULT hr, CString strError)
{
	CString strTemp; 

	// use the string if given 
	if (!strError.IsEmpty())
	{
		strTemp.Format(_T("Error - 0x%08X, %s"), hr, strError); 
		AfxMessageBox(strTemp); 
	}

	else 
	{
		// attempt to get the message from the system 
		LPVOID lpMsgBuf = NULL;
		if (FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL, hr, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL ))
		{
			strTemp.Format(_T("Error - 0x%08X, %s"), hr, lpMsgBuf); 
			AfxMessageBox(strTemp); 
			LocalFree(lpMsgBuf); 
		}

		// unknown error code
		else
		{
			strTemp.Format(_T("Unknown Error - 0x%08X"), hr); 
			AfxMessageBox(strTemp); 
		}
	}
}

// *********************************************************
//	PrintTitle
//
//	Prints a title string on the top of the page so we can 
//	identify the print mechanism. 
//
//	Arguments:
//
//		pDC - (CDC *) the printer device context
//		pInfo - (CPrintInfo *) the print info structure pointer	
//		strTitle - (CString, input) the title string 
//
//	Returns:
//
//		Nothing 
//

void CPrintControlView::PrintTitle(CDC* pDC, CPrintInfo* pInfo, CString strTitle)
{
	// create the font for the title (note assumes MM_TEXT mode)
	CFont fntPrintFont; 
	int nHeight = -MulDiv(10, pDC->GetDeviceCaps(LOGPIXELSY), 72);		// 10 point font 
	fntPrintFont.CreateFont(nHeight, 0, 0, 0, FW_DONTCARE, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_TT_PRECIS, 
							CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, _T("MS Shell Dlg")); 

	// switch to our font 
	CFont *pOldFont = pDC->SelectObject(&fntPrintFont); 

	// get a reference to the drawing rectangle
	CRect &rcPage = pInfo->m_rectDraw; 

	// draw the title
	int nCurrentY = rcPage.top + 100; 
	CSize sizeHeader = pDC->GetTextExtent(strTitle); 
	pDC->TextOut(100, nCurrentY, strTitle); 

	// move down a little 
	nCurrentY += sizeHeader.cy * 2; 

	// adjust the remaining printable area
	rcPage.top = nCurrentY; 

	// clean up 
	pDC->SelectObject(pOldFont); 
	fntPrintFont.DeleteObject(); 
}

// *********************************************************
//	OnPrint
//
//	Standard MFC print framework routine.  Called for print or
//	print preview. 
//
//	Arguments:
//
//		See the MFC documentation for OnPrint.
//
//	Returns:
//
//		Nothing
//

void CPrintControlView::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{
	// Note: in all cases we assume the printer can handle graphics, etc.

	// transfer choices to member variables
	UpdateData(TRUE); 

	// get the selected control 
	CWnd *pWnd = NULL; 
	if (m_nControlChoice == 0)
		pWnd = &m_ctlChart; 
	else if (m_nControlChoice == 1)
		pWnd = &m_ctlCalendar; 
	else
		pWnd = &m_ctlPicture; 

	// print using the selected radio option
	switch (m_nPrintChoice)
	{

		case 0:		// draw using a screen device context, then transfer to printer dc ourselves
			PrintTitle(pDC, pInfo, _T("IViewObject::Draw (Screen DC)")); 
			PrintControlUsingScreen(pWnd, pDC, pInfo); 
			break; 

		case 1:		// draw using the printer device context directly
			PrintTitle(pDC, pInfo, _T("IViewObject::Draw (Printer DC)")); 
			PrintControlUsingPrinter(pWnd, pDC, pInfo); 
			break; 

		case 2:		// draw into a metafile, then transfer to the printer dc ourselves
			PrintTitle(pDC, pInfo, _T("IViewObject::Draw (Metafile)")); 
			PrintControlUsingMetafile(pWnd, pDC, pInfo); 
			break; 

		case 3:		// getdata into a metafile, then transfer to the printer dc ourselves
			PrintTitle(pDC, pInfo, _T("IDataObject::GetData (Metafile)")); 
			PrintControlGetData(pWnd, pDC, pInfo); 
			break; 

		case 4:		// use WM_PRINT to the print to the printer device context directly
			PrintTitle(pDC, pInfo, _T("WM_PRINT (Printer DC)")); 
			PrintControlWmPrint(pWnd, pDC, pInfo); 
			break; 

		default:
			ASSERT(FALSE);		// bad option selection
			break; 
	}
}

/////////////////////////////////////////////////////////////////////////////
// These are the functions that do the control printing. 
/////////////////////////////////////////////////////////////////////////////

// *********************************************************
//	PrintControlUsingScreen
//
//	Prints the control by using the IViewObject::Draw routine
//	to an offscreen memory device context.  This data is then 
//	simply transferred to the printer device context.  
//
//	This method is only used as a last choice because the 
//	quality will be the poorest.  However, in some cases, since
//	some controls don't handle drawing to printer or metafile
//	device contexts directly, this will be your only choice.  
//
//	In a sense, this method is equivalent to grabbing the image
//	from the screen and printing it.  By using the interfaces you 
//	don't have to worry if the window is obscured or hidden when 
//	you grab the image for printing.  
//
//	Arguments:
//
//		pWnd - (CWnd *, input) the control to print
//		pDC - (CDC *, input/output) the printer device context
//		pInfo - (CPrintInfo *, input) the printer info object pointer
//
//	Returns:
//
//		Nothing
//

void CPrintControlView::PrintControlUsingScreen(CWnd *pWnd, CDC* pDC, CPrintInfo* pInfo)
{
	// get the IUnknown pointer for the chart object (note, don't release this one per MSDN)
	LPUNKNOWN pUnk = pWnd->GetControlUnknown();
	if (!pUnk)
	{
		AfxMessageBox(_T("Not an ActiveX Control")); 
		return; 
	}

	// get a reference to the drawing rectangle
	CRect &rcPage = pInfo->m_rectDraw; 

	// maximize the image based on our drawing area, but keep the aspect ratio unchanged
	CRect rect; 
	pWnd->GetClientRect(&rect); 
	float grph_xyratio = (float) rect.Width() / (float) rect.Height(); 
	float page_xyratio = (float) rcPage.Width() / (float) rcPage.Height(); 

	// determine the limiting dimension 
	float width, height; 
	if (grph_xyratio > page_xyratio)
	{
		// the x dimension is the limiting factor
		width = (float) rcPage.Width(); 
		height = rcPage.Width() / grph_xyratio; 
	}
	else
	{
		// the y dimension is the limiting factor 
		height = (float) rcPage.Height(); 
		width = rcPage.Height() * grph_xyratio; 
	}

	// build the rectangle to print in
	RECTL rectPrn; 
	rectPrn.top = 0; 
	rectPrn.left = 0;
	rectPrn.right = rect.Width() - 1;
	rectPrn.bottom = rect.Height() - 1; 

	// get the dc of the current display 
	CDC dc; 
	HDC hdc = ::GetDC(m_hWnd); 
	dc.Attach(hdc); 

	// offscreen memory and bitmap support
	CDC dcMem; 
	CBitmap bmpMem; 
	CBitmap *oldbm = NULL; 
	LPVOID lpvBits = NULL; 

	// save the device context
	pDC->SaveDC(); 

	// do the drawing 
	HRESULT hRes = S_OK; 
	try 
	{
		// create a memory device context for offscreen drawing
		if (!dcMem.CreateCompatibleDC(&dc))
			_com_issue_error(HRESULT_FROM_WIN32(::GetLastError())); 
		if (!bmpMem.CreateCompatibleBitmap(&dc, rect.Width(), rect.Height()))
			_com_issue_error(HRESULT_FROM_WIN32(::GetLastError())); 
		oldbm = dcMem.SelectObject(&bmpMem); 

		// query for the IViewObject interface for printing (note, some don't support this, like lite controls)
		IViewObjectPtr spViewObj; 
		hRes = pUnk->QueryInterface(__uuidof(spViewObj), (void **) &spViewObj); 	
		if (FAILED(hRes)) _com_issue_error(hRes); 

		// draw the object into our screen device context
		hRes = spViewObj->Draw(DVASPECT_CONTENT, -1, NULL, NULL, NULL, dcMem, &rectPrn, NULL, NULL, 0); 
		if (FAILED(hRes)) _com_issue_error(hRes); 

		// delesect the device dependent bitmap from the offscreen device context (must be out when GetDIBits is called)
		dcMem.SelectObject(oldbm); 

		// get the header structure for a device independent bitmap (DIB) setup with the biggest possible palette
		BITMAPINFO *bmi = (BITMAPINFO *) _alloca(sizeof(BITMAPINFOHEADER) + 256 * sizeof(RGBQUAD)); 
		memset(&bmi->bmiHeader, 0, sizeof(BITMAPINFOHEADER)); 
		bmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER); 

		// query for the bitmap information (NULL does a query)
		int scanLineCount = GetDIBits(dcMem, bmpMem, 0, rect.Height(), NULL, bmi, DIB_RGB_COLORS); 
		if (!scanLineCount) 
			_com_issue_error(HRESULT_FROM_WIN32(::GetLastError())); 

		// allocate memory for the bitmap bits 
		lpvBits = new char[bmi->bmiHeader.biSizeImage]; 
		if (!lpvBits) 
			_com_issue_error(HRESULT_FROM_WIN32(ERROR_OUTOFMEMORY));

		// convert the device dependent bitmap to the DIB
		// (See knowledge base article Q195830 for details)
		scanLineCount = GetDIBits(dcMem, bmpMem, 0, rect.Height(), lpvBits, bmi, DIB_RGB_COLORS); 
		if (!scanLineCount) 
			_com_issue_error(HRESULT_FROM_WIN32(::GetLastError())); 

		// transfer the device independent bitmap to our printer device context
		if (GDI_ERROR == StretchDIBits(pDC->m_hDC, rcPage.left, rcPage.top, (int) width, (int) height, 0, 0, rect.Width(), rect.Height(), lpvBits, bmi, DIB_RGB_COLORS, SRCCOPY))
			_com_issue_error(HRESULT_FROM_WIN32(::GetLastError())); 

	}
	catch (_com_error & e)
	{
		ErrorMessage(e.Error(), (LPCTSTR) e.Description()); 
	}

	// restore the device context
	pDC->RestoreDC(-1); 

	// free the bitmap memory 
	if (lpvBits) delete [] lpvBits; 
}

// *********************************************************
//	PrintControlUsingPrinter
//
//	Prints the control by using the IViewObject::Draw routine
//	directly to the printer device context.  
//
//	If the control handles this properly, the output will look
//	very good (better than the PrintControlUsingScreen case).
//
//	This is the way Internet Explorer 4.0 does it. 
//
//	Arguments:
//
//		pWnd - (CWnd *, input) the control to print
//		pDC - (CDC *, input/output) the printer device context
//		pInfo - (CPrintInfo *, input) the printer info object pointer
//
//	Returns:
//
//		Nothing
//

void CPrintControlView::PrintControlUsingPrinter(CWnd *pWnd, CDC* pDC, CPrintInfo* pInfo)
{
	// get the IUnknown pointer for the chart object (note, don't release this one per MSDN)
	LPUNKNOWN pUnk = pWnd->GetControlUnknown();
	if (!pUnk)
	{
		AfxMessageBox(_T("Not an ActiveX Control")); 
		return; 
	}

	// get a reference to the drawing rectangle
	CRect &rcPage = pInfo->m_rectDraw; 

	// maximize the image based on our drawing area, but keep the aspect ratio unchanged
	CRect rect; 
	pWnd->GetClientRect(&rect); 
	float grph_xyratio = (float) rect.Width() / (float) rect.Height(); 
	float page_xyratio = (float) rcPage.Width() / (float) rcPage.Height(); 

	// determine the limiting dimension 
	float width, height; 
	if (grph_xyratio > page_xyratio)
	{
		// the x dimension is the limiting factor
		width = (float) rcPage.Width(); 
		height = rcPage.Width() / grph_xyratio; 
	}
	else
	{
		// the y dimension is the limiting factor 
		height = (float) rcPage.Height(); 
		width = rcPage.Height() * grph_xyratio; 
	}

	// build the rectangle to print in
	RECTL rectPrn; 
	rectPrn.top = rcPage.top; 
	rectPrn.left = rcPage.left;
	rectPrn.right = rcPage.left + (int) width - 1;
	rectPrn.bottom = rcPage.top + (int) height - 1; 

	// save the device context
	pDC->SaveDC(); 

	// do the drawing 
	HRESULT hRes = S_OK; 
	try 
	{
		// query for the IViewObject interface for printing (note, some don't support this, like lite controls)
		IViewObjectPtr spViewObj; 
		hRes = pUnk->QueryInterface(__uuidof(spViewObj), (void **) &spViewObj); 	
		if (FAILED(hRes)) _com_issue_error(hRes); 

		// draw the object into the printer device context
		hRes = spViewObj->Draw(DVASPECT_CONTENT, -1, NULL, NULL, NULL, pDC->m_hDC, &rectPrn, NULL, NULL, 0); 
		if (FAILED(hRes)) _com_issue_error(hRes); 

	}
	catch (_com_error & e)
	{
		ErrorMessage(e.Error(), (LPCTSTR) e.Description()); 
	}

	// restore the device context
	pDC->RestoreDC(-1); 
}

// *********************************************************
//	PrintControlUsingMetafile
//
//	Prints the control by using the IViewObject::Draw routine
//	to draw to a metafile.  We then transfer to the metafile
//	to the printer ourselves.  
//
//	This is the way Visual Basic 6.0 works when you use the 
//	PrintForm method.  
//
//	Note, not all controls print properly to a metafile.  
//	You can use the ActiveX Control test container's "Draw Metafile"
//	option to test it.  
//
//	Arguments:
//
//		pWnd - (CWnd *, input) the control to print
//		pDC - (CDC *, input/output) the printer device context
//		pInfo - (CPrintInfo *, input) the printer info object pointer
//
//	Returns:
//
//		Nothing
//

void CPrintControlView::PrintControlUsingMetafile(CWnd *pWnd, CDC* pDC, CPrintInfo* pInfo)
{
	// get the IUnknown pointer for the chart object (note, don't release this one per MSDN)
	LPUNKNOWN pUnk = pWnd->GetControlUnknown();
	if (!pUnk)
	{
		AfxMessageBox(_T("Not an ActiveX Control")); 
		return; 
	}

	// get a reference to the drawing rectangle
	CRect &rcPage = pInfo->m_rectDraw; 

	// maximize the image based on our drawing area, but keep the aspect ratio unchanged
	CRect rect; 
	pWnd->GetClientRect(&rect); 
	float grph_xyratio = (float) rect.Width() / (float) rect.Height(); 
	float page_xyratio = (float) rcPage.Width() / (float) rcPage.Height(); 

	// determine the limiting dimension 
	float width, height; 
	if (grph_xyratio > page_xyratio)
	{
		// the x dimension is the limiting factor
		width = (float) rcPage.Width(); 
		height = rcPage.Width() / grph_xyratio; 
	}
	else
	{
		// the y dimension is the limiting factor 
		height = (float) rcPage.Height(); 
		width = rcPage.Height() * grph_xyratio; 
	}

	// build the rectangle to print in
	RECTL rectPrn; 
	rectPrn.top = rcPage.top; 
	rectPrn.left = rcPage.left;
	rectPrn.right = rcPage.left + (int) width - 1;
	rectPrn.bottom = rcPage.top + (int) height - 1; 

	// save the device context
	pDC->SaveDC(); 

	// do the drawing 
	HRESULT hRes = S_OK; 
	try 
	{
		// create a metafile to draw into 
		CMetaFileDC dcMeta; 
		if (!dcMeta.Create())
			_com_issue_error(HRESULT_FROM_WIN32(::GetLastError())); 

		// query for the IViewObject interface for printing (note, some don't support this, like lite controls)
		IViewObjectPtr spViewObj; 
		hRes = pUnk->QueryInterface(__uuidof(spViewObj), (void **) &spViewObj); 	
		if (FAILED(hRes)) _com_issue_error(hRes); 

		// draw the object into the metafile device context
		hRes = spViewObj->Draw(DVASPECT_CONTENT, -1, NULL, NULL, NULL, dcMeta, &rectPrn, NULL, NULL, 0); 
		if (FAILED(hRes)) _com_issue_error(hRes); 

		// get the completed meta file handle
		HMETAFILE hMeta = dcMeta.Close(); 
		if (!hMeta) 
			_com_issue_error(HRESULT_FROM_WIN32(::GetLastError())); 

		// play the meta file into the printer device context
		pDC->PlayMetaFile(hMeta); 

		// free up the metafile memory 
		DeleteMetaFile(hMeta); 
	}
	catch (_com_error & e)
	{
		ErrorMessage(e.Error(), (LPCTSTR) e.Description()); 
	}

	// restore the device context
	pDC->RestoreDC(-1); 
}

// *********************************************************
//	PrintControlGetData
//
//	Prints the control by using the IViewObject::GetData routine
//	to draw to a metafile.  We then transfer to the metafile
//	to the printer ourselves.  
//
//	This is the way Word 97 works. 
//
//	Arguments:
//
//		pWnd - (CWnd *, input) the control to print
//		pDC - (CDC *, input/output) the printer device context
//		pInfo - (CPrintInfo *, input) the printer info object pointer
//
//	Returns:
//
//		Nothing
//

void CPrintControlView::PrintControlGetData(CWnd *pWnd, CDC* pDC, CPrintInfo* pInfo)
{
	// get the IUnknown pointer for the chart object (note, don't release this one per MSDN)
	LPUNKNOWN pUnk = pWnd->GetControlUnknown();
	if (!pUnk)
	{
		AfxMessageBox(_T("Not an ActiveX Control")); 
		return; 
	}

	// get a reference to the drawing rectangle
	CRect &rcPage = pInfo->m_rectDraw; 

	// maximize the image based on our drawing area, but keep the aspect ratio unchanged
	CRect rect; 
	pWnd->GetClientRect(&rect); 
	float grph_xyratio = (float) rect.Width() / (float) rect.Height(); 
	float page_xyratio = (float) rcPage.Width() / (float) rcPage.Height(); 

	// determine the limiting dimension 
	float width, height; 
	if (grph_xyratio > page_xyratio)
	{
		// the x dimension is the limiting factor
		width = (float) rcPage.Width(); 
		height = rcPage.Width() / grph_xyratio; 
	}
	else
	{
		// the y dimension is the limiting factor 
		height = (float) rcPage.Height(); 
		width = rcPage.Height() * grph_xyratio; 
	}

	// build the rectangle to print in
	RECTL rectPrn; 
	rectPrn.top = rcPage.top; 
	rectPrn.left = rcPage.left;
	rectPrn.right = rcPage.left + (int) width - 1;
	rectPrn.bottom = rcPage.top + (int) height - 1; 

	// save the device context
	pDC->SaveDC(); 

	// do the drawing 
	HRESULT hRes = S_OK; 
	try 
	{
		// query for the IDataObject interface for GetData (some controls don't support this)
		IDataObjectPtr spDataObj; 
		hRes = pUnk->QueryInterface(__uuidof(spDataObj), (void **) &spDataObj); 	
		if (FAILED(hRes)) _com_issue_error(hRes); 

		// setup the structures for retrieving the results 
		FORMATETC Formatetc;
		Formatetc.cfFormat = CF_METAFILEPICT; 
		Formatetc.ptd = NULL; 
		Formatetc.dwAspect = DVASPECT_CONTENT; 
		Formatetc.lindex = -1; 
		Formatetc.tymed = TYMED_MFPICT; 
		STGMEDIUM Medium = { 0 }; 

		// draw the control into a metafile 
		hRes = spDataObj->GetData(&Formatetc, &Medium); 
		if (FAILED(hRes)) _com_issue_error(hRes); 

		// the returned type should be a metafile since that's what we requested
		if (Medium.tymed & TYMED_MFPICT)
		{
			// get the metafile picture pointer so we can get the metafile handle
			METAFILEPICT *pMetaPict = (METAFILEPICT *) GlobalLock(Medium.hMetaFilePict); 

			// scale appropriately 
			pDC->SetMapMode(pMetaPict->mm); 
			pDC->SetViewportOrg(rectPrn.left, rectPrn.top);
			pDC->SetViewportExt(rectPrn.right - rectPrn.left + 1, rectPrn.bottom - rectPrn.top + 1);

			// play the meta file into the printer device context
			pDC->PlayMetaFile(pMetaPict->hMF); 

			// unlock the metafile picture handle
			GlobalUnlock(Medium.hMetaFilePict); 

			// release the results 
			ReleaseStgMedium(&Medium); 
		}

	}
	catch (_com_error & e)
	{
		ErrorMessage(e.Error(), (LPCTSTR) e.Description()); 
	}

	// restore the device context
	pDC->RestoreDC(-1); 
}

// *********************************************************
//	PrintControlWmPrint
//
//	Prints the control by sending the WM_PRINT message to 
//	the control. 
//
//	Note: not all controls seem to handle this well. 
//
//	Arguments:
//
//		pWnd - (CWnd *, input) the control to print
//		pDC - (CDC *, input/output) the printer device context
//		pInfo - (CPrintInfo *, input) the printer info object pointer
//
//	Returns:
//
//		Nothing
//

void CPrintControlView::PrintControlWmPrint(CWnd *pWnd, CDC* pDC, CPrintInfo* pInfo)
{
	// get a reference to the drawing rectangle
	CRect &rcPage = pInfo->m_rectDraw; 

	// save the device context
	pDC->SaveDC(); 

	// place at the correct location
	pDC->SetViewportOrg(rcPage.left, rcPage.top);

	// send the message to print the control (could use pWnd->Print directly)
	LRESULT lRes = pWnd->SendMessage(WM_PRINT, (WPARAM) pDC->GetSafeHdc(), PRF_CLIENT | PRF_CHILDREN | PRF_OWNED); 

	// restore the device context
	pDC->RestoreDC(-1); 
}

